import { Action } from 'redux';
import { BaseModel } from '../models/BaseModel';
export interface IActionPayload<Payload = any, T = string> extends Action<T> {
    payload: Payload;
}
export declare const actionProxyKeys: {
    methods: (keyof BaseAction<any>)[];
    getters: (keyof BaseAction<any>)[];
};
export declare abstract class BaseAction<Data> {
    protected readonly model: BaseModel<Data>;
    protected instanceName: string;
    protected __successType?: string;
    private readonly __isAction__: boolean;
    protected constructor(model: BaseModel<Data>);
    getSuccessType(): string;
    protected getActionName(): string;
    protected setName(name: string | number): void;
    protected proxy(): this;
    protected getProxyMethods(): string[];
    protected getProxyGetters(): string[];
    protected abstract getProxyFn(): Function;
}
