import { BaseAction } from './BaseAction';
import { Meta, IMetaAction } from '../models/MetaModel';
import { BaseModel, State, StateReturn } from '../models/BaseModel';
import { Action } from 'redux';
export interface IActionCompose extends Action<string>, IMetaAction {
    message?: string;
}
export interface ComposeSubscriber<CustomData> {
    when: string;
    effect: (state: State<CustomData>) => StateReturn<CustomData>;
}
export declare const composeActionProxyKeys: {
    methods: (keyof ComposeAction<any, any>)[];
    getters: (keyof ComposeAction<any, any>)[];
};
export declare class ComposeAction<Data, Runner extends (...args: any[]) => Promise<any>> extends BaseAction<Data> {
    protected readonly runner: Runner;
    private __prepareType?;
    private __failType?;
    static proxyKeys: {
        methods: (keyof ComposeAction<any, any>)[];
        getters: (keyof ComposeAction<any, any>)[];
    };
    constructor(model: BaseModel<Data>, runner: Runner, fromSubClass?: boolean);
    get meta(): Meta;
    get loading(): boolean;
    /**
     * @override
     */
    protected getProxyMethods(): string[];
    /**
     * @override
     */
    protected getProxyGetters(): string[];
    protected getProxyFn(): Function;
    /**
     * @override
     */
    protected setName(name: string | number): void;
    getPrepareType(): string;
    getFailType(): string;
    onSuccess<CustomData>(effect: ComposeSubscriber<CustomData>['effect']): ComposeSubscriber<CustomData>;
    onPrepare<CustomData>(effect: ComposeSubscriber<CustomData>['effect']): ComposeSubscriber<CustomData>;
    onFail<CustomData>(effect: ComposeSubscriber<CustomData>['effect']): ComposeSubscriber<CustomData>;
}
