"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.metaModel = exports.MetaModel = exports.DEFAULT_METAS = exports.METAS_PICK_METHOD = exports.DEFAULT_META = void 0;
var tslib_1 = require("tslib");
var BaseModel_1 = require("./BaseModel");
var MetaReducer_1 = require("../reducers/MetaReducer");
var StoreHelper_1 = require("../stores/StoreHelper");
exports.DEFAULT_META = {
    actionType: '',
    loading: false,
};
exports.METAS_PICK_METHOD = {
    pick: function (payload) {
        return this[payload] || exports.DEFAULT_META;
    },
};
// @ts-ignore
exports.DEFAULT_METAS = tslib_1.__assign({}, exports.METAS_PICK_METHOD);
var MetaModel = /** @class */ (function (_super) {
    tslib_1.__extends(MetaModel, _super);
    function MetaModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // All metas will be stored here before user need them.
        _this.stash = {};
        return _this;
    }
    MetaModel.prototype.getReducerName = function () {
        return '__metas__';
    };
    MetaModel.prototype.register = function () {
        var reducer = new MetaReducer_1.MetaReducer(this.stash, this);
        return reducer.createReducer();
    };
    MetaModel.prototype.getMeta = function (name) {
        var stash = this.stash[name];
        if (!this.data[name] && stash && stash !== MetaReducer_1.USED_FLAG) {
            var action = {
                type: MetaReducer_1.META_RESTORE,
                payload: {
                    key: name,
                    value: stash,
                },
            };
            StoreHelper_1.storeHelper.dispatch(action);
        }
        if (stash !== MetaReducer_1.USED_FLAG) {
            this.stash[name] = MetaReducer_1.USED_FLAG;
        }
        return this.data[name];
    };
    MetaModel.prototype.initReducer = function () {
        return {};
    };
    return MetaModel;
}(BaseModel_1.BaseModel));
exports.MetaModel = MetaModel;
exports.metaModel = new MetaModel();
