import { Effects, BaseModel } from '../models/BaseModel';
import { InternalSuccessAction } from '../actions/BaseRequestAction';
import { IActionNormal } from '../actions/NormalAction';
export interface IReducers {
    [key: string]: (state: any, action: any) => any;
}
export declare class BaseReducer<Data> {
    protected readonly model: BaseModel<Data>;
    protected readonly initData: Data;
    protected readonly reducerName: string;
    protected readonly sideEffects: Record<string, Effects<Data>[number]['effect']>;
    constructor(model: BaseModel<Data>);
    createReducer(): IReducers;
    protected reducer(state: Data | undefined, action: InternalSuccessAction<Data> | IActionNormal<Data>): Data;
    protected initFromPersist(state: any): any;
    protected changeState(effect: Function, state: any, action: InternalSuccessAction<Data> | IActionNormal<Data>): any;
}
