"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetaReducer = exports.USED_FLAG = exports.META_RESTORE = void 0;
var tslib_1 = require("tslib");
var BaseReducer_1 = require("./BaseReducer");
var MetaModel_1 = require("../models/MetaModel");
exports.META_RESTORE = '@flus/meta/restore';
exports.USED_FLAG = '@flus/used';
var MetaReducer = /** @class */ (function (_super) {
    tslib_1.__extends(MetaReducer, _super);
    function MetaReducer(stash, model) {
        var _this = _super.call(this, model) || this;
        _this.stash = {};
        _this.stash = stash;
        return _this;
    }
    MetaReducer.prototype.isRestore = function (action) {
        return action.type === exports.META_RESTORE;
    };
    MetaReducer.prototype.reducer = function (state, action) {
        var _a, _b, _c, _d;
        if (state === undefined) {
            return this.initData;
        }
        if (this.isRestore(action)) {
            return tslib_1.__assign(tslib_1.__assign({}, state), (_a = {}, _a[action.payload.key] = action.payload.value, _a));
        }
        var metaKey = action.metaKey;
        var actionName = action.metaActionName;
        if (!actionName || metaKey === undefined || metaKey === false) {
            return state;
        }
        var meta = {
            actionType: action.type,
            loading: action.loading,
            message: action.message,
            httpStatus: action.httpStatus,
            businessCode: action.businessCode,
        };
        var used = this.stash[actionName] === exports.USED_FLAG;
        if (metaKey === true) {
            if (used) {
                return tslib_1.__assign(tslib_1.__assign({}, state), (_b = {}, _b[actionName] = meta, _b));
            }
            this.stash[actionName] = meta;
        }
        else {
            if (used) {
                return tslib_1.__assign(tslib_1.__assign({}, state), (_c = {}, _c[actionName] = tslib_1.__assign(tslib_1.__assign(tslib_1.__assign({}, state[actionName]), (_d = {}, _d[metaKey] = meta, _d)), MetaModel_1.METAS_PICK_METHOD), _c));
            }
            this.stash[actionName] = this.stash[actionName] || tslib_1.__assign({}, MetaModel_1.METAS_PICK_METHOD);
            this.stash[actionName][metaKey] = meta;
        }
        return state;
    };
    return MetaReducer;
}(BaseReducer_1.BaseReducer));
exports.MetaReducer = MetaReducer;
