import { METHOD } from '../utils/method';
import { IBaseRequestAction } from '../actions/BaseRequestAction';
import { ThrottleOptionns } from './HttpServiceBuilder';
export declare type OrphanRequestOptions<T> = Partial<Pick<IBaseRequestAction, 'uri' | 'query' | 'body' | 'requestOptions'>> & {
    uri: string;
    requestOptions?: T;
    throttle?: number | ThrottleOptionns;
};
export declare class OrphanHttpService<T = object> {
    protected readonly uniqueId: number;
    protected readonly config: OrphanRequestOptions<T>;
    protected readonly method: METHOD;
    constructor(config: OrphanRequestOptions<T>, method: METHOD, uniqueId: number);
    collect(): IBaseRequestAction;
}
