"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrphanHttpService = void 0;
var method_1 = require("../utils/method");
var OrphanHttpService = /** @class */ (function () {
    function OrphanHttpService(config, method, uniqueId) {
        this.method = method_1.METHOD.get;
        this.config = config;
        this.uniqueId = uniqueId;
        this.method = method;
    }
    OrphanHttpService.prototype.collect = function () {
        var config = this.config;
        var throttle = config.throttle === undefined
            ? {
                duration: 0,
                enable: false,
            }
            : typeof config.throttle === 'number'
                ? { duration: config.throttle }
                : config.throttle;
        var action = {
            uniqueId: this.uniqueId,
            body: config.body || {},
            query: config.query || {},
            successText: '',
            failText: '',
            hideError: true,
            requestOptions: config.requestOptions || {},
            uri: config.uri,
            type: {
                prepare: '',
                success: 'orphan http request',
                fail: '',
            },
            method: this.method,
            useThrottle: throttle.enable !== false,
            throttleMillSeconds: throttle.duration,
            throttleDeps: throttle.deps || [],
            throttleKey: '',
            metaKey: false,
            metaActionName: '',
            payload: undefined,
            onPrepare: null,
            onSuccess: null,
            onFail: null,
            modelName: '',
        };
        return action;
    };
    return OrphanHttpService;
}());
exports.OrphanHttpService = OrphanHttpService;
